<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">      
      <el-form-item label="项目" prop="projectId">        
        <el-select v-model="queryParams.projectId" filterable  placeholder="请选择项目" clearable>
          <el-option v-for="(item, index) in projectOptions"  :key="index" :label="item.projectName" :value="item.id">
          </el-option>
        </el-select>
      </el-form-item>      
      <el-form-item label="视频日期" prop="videoDate">
        <el-date-picker clearable v-model="queryParams.videoDate" :picker-options="dtOptStart" type="date" value-format="yyyy-MM-dd"
          placeholder="请选择开始日期">
        </el-date-picker>
        -
        <el-date-picker clearable v-model="queryParams.updateDate" :picker-options="dtOptEnd" type="date" value-format="yyyy-MM-dd"
          placeholder="请选择结束日期">
        </el-date-picker> 
      </el-form-item>      
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">     
      <el-col :span="1.5">
        <el-button type="danger" plain icon="el-icon-delete" size="mini" :disabled="multiple" @click="handleDelete"
          v-hasPermi="['video:prjphotography:remove']">删除</el-button>
      </el-col>      
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="prjphotographyList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="项目" align="left" prop="remark"/>
      <el-table-column label="月份" align="center" prop="videoDate" width="180">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.videoDate, '{y}-{m}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="图片路径" align="center" prop="imageUrl" >
        <template slot-scope="{row}">
          <el-image ref="preview" style="height: 80px; " :preview-src-list="row.images"
                            :src="row.image + '.min.jpg'">
                        </el-image>
        </template>
      </el-table-column>
      <el-table-column label="视频路径" align="center" prop="videoUrl" >
        <template slot-scope="{row}">
          <video  height="80" controls :key="row.videoUrl" v-if="row.videoUrl">
            <source :src="row.videoUrl" type="video/mp4"/>
          您的浏览器不支持Video标签。
          </video>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">          
          <el-button size="mini" type="text" icon="el-icon-delete" @click="handleDelete(scope.row)"
            v-hasPermi="['video:prjphotography:remove']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNum" :limit.sync="queryParams.pageSize"
      @pagination="getList" />

    <!-- 添加或修改项目延时摄影对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="项目ID" prop="projectId">
          <el-input v-model="form.projectId" placeholder="请输入项目ID" />
        </el-form-item>
        <el-form-item label="图片路径" prop="imageUrl">
          <el-input v-model="form.imageUrl" type="textarea" placeholder="请输入内容" />
        </el-form-item>
        <el-form-item label="视频路径" prop="videoUrl">
          <el-input v-model="form.videoUrl" placeholder="请输入视频路径" />
        </el-form-item>
        <el-form-item label="视频日期" prop="videoDate">
          <el-date-picker clearable v-model="form.videoDate" type="date" value-format="yyyy-MM-dd"
            placeholder="请选择视频日期">
          </el-date-picker>
        </el-form-item>
        <el-form-item label="状态" prop="state">
          <el-input v-model="form.state" placeholder="请输入状态" />
        </el-form-item>
        <el-form-item label="备注" prop="remark">
          <el-input v-model="form.remark" placeholder="请输入备注" />
        </el-form-item>
        <el-form-item label="" prop="isDel">
          <el-input v-model="form.isDel" placeholder="请输入" />
        </el-form-item>
        <el-form-item label="" prop="createDate">
          <el-date-picker clearable v-model="form.createDate" type="date" value-format="yyyy-MM-dd" placeholder="请选择">
          </el-date-picker>
        </el-form-item>
        <el-form-item label="" prop="updateDate">
          <el-date-picker clearable v-model="form.updateDate" type="date" value-format="yyyy-MM-dd" placeholder="请选择">
          </el-date-picker>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { queryPrjphotography, getPrjphotography, delPrjphotography, addPrjphotography, updatePrjphotography } from "@/api/video/prjphotography";

export default {
  name: "Prjphotography",
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 项目延时摄影表格数据
      prjphotographyList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      projectOptions:[],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        projectId: null,
        imageUrl: null,
        videoUrl: null,
        videoDate: null,
        state: null,
        isDel: null,
        createDate: null,
        updateDate: null
      },
      dtOptStart:{
        disabledDate:d=>{
          return this.disabledDate(d,1)
        }
      },
      dtOptEnd:{
        disabledDate:d=>{
          return this.disabledDate(d,2)
        }
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      }
    };
  },
  created() {
    this.getList();
    this.$api.publics.getMyProjectList({}).then((response) => {
        this.projectOptions = response.rows;
    });
  },
  methods: {
    disabledDate(d,t){
      if(t==1){
        if(!this.queryParams.updateDate){
          return false;
        }
        return +this.$dt(this.queryParams.updateDate).$d<+d;
      }else{
        if(!this.queryParams.videoDate){
          return false;
        }
        return +this.$dt(this.queryParams.videoDate).$d>+d;
      }
    },
    /** 查询项目延时摄影列表 */
    getList() {
      this.loading = true;
      queryPrjphotography(this.queryParams).then(response => {
        this.prjphotographyList = (response.rows||[]).map(it=>{
          let tmps=it.imageUrl?this.$tryToJson(it.imageUrl,[]):[];
          it.imageUrls=tmps;
          it.images=tmps.map(item=>item.url);
          it.image=it.images.length>0?it.images[0]:'';
          return it;
        });
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        projectId: null,
        imageUrl: null,
        videoUrl: null,
        videoDate: null,
        state: null,
        remark: null,
        isDel: null,
        createBy: null,
        createDate: null,
        updateBy: null,
        updateDate: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加项目延时摄影";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getPrjphotography(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改项目延时摄影";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updatePrjphotography(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addPrjphotography(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal.confirm('是否确认删除项目延时摄影编号为"' + ids + '"的数据项？').then(function () {
        return delPrjphotography(ids);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => { });
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('video/prjphotography/export', {
        ...this.queryParams
      }, `prjphotography_${new Date().getTime()}.xlsx`)
    }
  }
};
</script>
